<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

/**
 * App\Models\Attribute
 *
 * @property int $id
 * @property int|null $parent_id
 * @property string $name
 * @property array|null $trans_name
 * @property int|null $pos
 * @property int $active
 * @property \Illuminate\Support\Carbon|null $created_at
 * @property \Illuminate\Support\Carbon|null $updated_at
 * @property-read \Illuminate\Database\Eloquent\Collection|\App\Models\Attribute[] $childrens
 * @property-read \App\Models\Attribute|null $parent
 * @method static \Illuminate\Database\Eloquent\Builder|\App\Models\Attribute whereActive($value)
 * @method static \Illuminate\Database\Eloquent\Builder|\App\Models\Attribute whereCreatedAt($value)
 * @method static \Illuminate\Database\Eloquent\Builder|\App\Models\Attribute whereId($value)
 * @method static \Illuminate\Database\Eloquent\Builder|\App\Models\Attribute whereName($value)
 * @method static \Illuminate\Database\Eloquent\Builder|\App\Models\Attribute whereParentId($value)
 * @method static \Illuminate\Database\Eloquent\Builder|\App\Models\Attribute wherePos($value)
 * @method static \Illuminate\Database\Eloquent\Builder|\App\Models\Attribute whereTransName($value)
 * @method static \Illuminate\Database\Eloquent\Builder|\App\Models\Attribute whereUpdatedAt($value)
 * @mixin \Eloquent
 * @property string|null $slug
 * @method static \Illuminate\Database\Eloquent\Builder|\App\Models\Attribute whereSlug($value)
 * @method static \Illuminate\Database\Eloquent\Builder|\App\Models\Attribute newModelQuery()
 * @method static \Illuminate\Database\Eloquent\Builder|\App\Models\Attribute newQuery()
 * @method static \Illuminate\Database\Eloquent\Builder|\App\Models\Attribute query()
 * @property-read int|null $childrens_count
 */
class Attribute extends Model
{
    protected $table = 'attributes';

    protected $casts = ['trans_name' => 'array'];

    protected $fillable = [
        'parent_id', 'name', 'pos', 'active',
    ];


    public function parent()
    {
        return $this->belongsTo('App\Models\Attribute', 'parent_id');
    }

    public function childrens()
    {
        return $this->hasMany('App\Models\Attribute', 'parent_id', 'id');
    }

    public function setPosAttribute($value){
        $this->attributes['pos'] = is_numeric($value) ? $value : null;

    }
    public function getLang($key)
    {
        $lang = \App::getLocale();
        if ($lang == 'de') {
            return $this->{$key};
        }
        $trans = $this->getTrans($key, $lang);
        if (!$trans || $trans == '') {
            return $this->{$key};
        }
        return $trans;
    }

    public function getTrans($key, $lang)
    {
        $key = 'trans_' . $key;
        if (!empty($this->{$key}[$lang])) {
            return $this->{$key}[$lang];
        }
    }

    public function getTranNames()
    {
        $ret = "";
        foreach ((array) $this->trans_name as $value){
            $ret .= $value.', ';
        }
        return rtrim($ret, ', ');
    }

}
